# HG changeset patch
# Node ID fc6b7bb79196
# Parent  c4a96b5eecba
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -46,6 +46,7 @@
 	'purplechatuser.c',
 	'purpleconnectionerrorinfo.c',
 	'purplecontact.c',
+	'purplecontactinfo.c',
 	'purplecontactmanager.c',
 	'purpleconversation.c',
 	'purpleconversationmanager.c',
@@ -150,6 +151,7 @@
 	'purplechatuser.h',
 	'purpleconnectionerrorinfo.h',
 	'purplecontact.h',
+	'purplecontactinfo.h',
 	'purplecontactmanager.h',
 	'purpleconversation.h',
 	'purpleconversationmanager.h',
@@ -260,7 +262,7 @@
 	'plugins.h',
 	'purplechatuser.h',
 	'purpleconnectionerrorinfo.h',
-	'purplecontact.h',
+	'purplecontactinfo.h',
 	'purpleconversation.h',
 	'purpleimconversation.h',
 	'purplemessage.h',
diff --git a/libpurple/protocols/ircv3/purpleircv3messagehandlers.c b/libpurple/protocols/ircv3/purpleircv3messagehandlers.c
--- a/libpurple/protocols/ircv3/purpleircv3messagehandlers.c
+++ b/libpurple/protocols/ircv3/purpleircv3messagehandlers.c
@@ -168,7 +168,7 @@
 	                                                    source);
 	if(!PURPLE_IS_CONTACT(contact)) {
 		contact = purple_contact_new(account, NULL);
-		purple_contact_set_username(contact, source);
+		purple_contact_info_set_username(PURPLE_CONTACT_INFO(contact), source);
 		purple_contact_manager_add(contact_manager, contact);
 	}
 
diff --git a/libpurple/purplecontact.h b/libpurple/purplecontact.h
--- a/libpurple/purplecontact.h
+++ b/libpurple/purplecontact.h
@@ -28,62 +28,22 @@
 
 #include <gdk-pixbuf/gdk-pixbuf.h>
 
-#include <libpurple/purplepresence.h>
-#include <libpurple/purpletags.h>
+#include <libpurple/purplecontactinfo.h>
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CONTACT (purple_contact_get_type())
-G_DECLARE_DERIVABLE_TYPE(PurpleContact, purple_contact, PURPLE, CONTACT,
-                         GObject)
-
-/**
- * PurpleContactPermission:
- * @PURPLE_CONTACT_PERMISSION_UNSET: The value is unset.
- * @PURPLE_CONTACT_PERMISSION_ALLOW: The contact is allowed to contact the
- *                                   user.
- * @PURPLE_CONTACT_PERMISSION_DENY: The contact is not allowed to contact the
- *                                  user.
- *
- * A representation of whether or not a contact has permission to contact the
- * user.
- *
- * Since: 3.0.0
- */
-typedef enum {
-	PURPLE_CONTACT_PERMISSION_UNSET = 0,
-	PURPLE_CONTACT_PERMISSION_ALLOW,
-	PURPLE_CONTACT_PERMISSION_DENY,
-} PurpleContactPermission;
+G_DECLARE_FINAL_TYPE(PurpleContact, purple_contact, PURPLE, CONTACT,
+                     PurpleContactInfo)
 
 #include <libpurple/account.h>
-#include <libpurple/purpleperson.h>
-
-/**
- * PurpleContactClass:
- * @get_account: A virtual method whose sole purpose is to allow
- *               [class@Purple.Account] to subclass [class@Purple.Contact].
- *
- * The class struct for [class@Purple.Contact].
- *
- * Since: 3.0.0
- */
-struct _PurpleContactClass {
-	/*< private >*/
-	GObjectClass parent;
-
-	/*< public >*/
-	PurpleAccount *(*get_account)(PurpleContact *contact);
-
-	/*< private >*/
-	gpointer reserved[4];
-};
 
 /**
  * PurpleContact:
  *
- * A representation of a user. Contacts are used everywhere you need to refer to
- * a user. Be it a chat, an direct message, a file transfer, etc.
+ * A contact is a concrete representation of a user in that it contains all of
+ * the contact information as well as a [class@Purple.Account] to use that
+ * contact information with.
  */
 
 /**
@@ -114,248 +74,6 @@
  */
 PurpleAccount *purple_contact_get_account(PurpleContact *contact);
 
-/**
- * purple_contact_get_id:
- * @contact: The instance.
- *
- * Gets the id of @contact.
- *
- * If a protocol would like to set this, it should call
- * [ctor@GObject.Object.new] and pass in the id attribute manually.
- *
- * Returns: The id of the contact.
- *
- * Since: 3.0.0
- */
-const gchar *purple_contact_get_id(PurpleContact *contact);
-
-/**
- * purple_contact_set_id:
- * @contact: The instance.
- * @id: The new identifier.
- *
- * Sets the identifier of @contact to @id. Note, this should be used rarely if
- * at all. The main intent of this, is for protocols to update the id of
- * [property@Purple.Account:contact] when an account is connected if it is
- * missing.
- *
- * Since: 3.0.0
- */
-void purple_contact_set_id(PurpleContact *contact, const char *id);
-
-/**
- * purple_contact_get_username:
- * @contact: The instance.
- *
- * Gets the username of @contact.
- *
- * Returns: The username of @contact.
- *
- * Since: 3.0.0
- */
-const gchar *purple_contact_get_username(PurpleContact *contact);
-
-/**
- * purple_contact_set_username:
- * @contact: The instance.
- * @username: The new username.
- *
- * Sets the username of @contact to @username.
- *
- * This is primarily used by protocol plugins like IRC when a user changes
- * their "nick" which is their username.
- *
- * Since: 3.0.0
- */
-void purple_contact_set_username(PurpleContact *contact, const gchar *username);
-
-/**
- * purple_contact_get_display_name:
- * @contact: The instance.
- *
- * Gets the display name for @contact. The display name is typically set by the
- * contact and is handled by the protocol plugin.
- *
- * Returns: (nullable): The display name of @contact if one is set, otherwise
- *          %NULL will be returned.
- *
- * Since: 3.0.0
- */
-const gchar *purple_contact_get_display_name(PurpleContact *contact);
-
-/**
- * purple_contact_set_display_name:
- * @contact: The instance.
- * @display_name: (nullable): The new displayname.
- *
- * Sets the display name of @contact to @display_name.
- *
- * This should primarily only be used by protocol plugins and everyone else
- * should be using [method@Purple.Contact.set_alias].
- *
- * Since: 3.0.0
- */
-void purple_contact_set_display_name(PurpleContact *contact, const gchar *display_name);
-
-/**
- * purple_contact_get_alias:
- * @contact: The instance.
- *
- * Gets the alias for @contact.
- *
- * Returns: (nullable): The alias of @contact if one is set, otherwise %NULL.
- *
- * Since: 3.0.0
- */
-const gchar *purple_contact_get_alias(PurpleContact *contact);
-
-/**
- * purple_contact_set_alias:
- * @contact: The instance.
- * @alias: (nullable): The new alias.
- *
- * Sets the alias of @contact to @alias.
- *
- * Protocol plugins may use this value to synchronize across instances.
- *
- * Since: 3.0.0
- */
-void purple_contact_set_alias(PurpleContact *contact, const gchar *alias);
-
-/**
- * purple_contact_get_avatar:
- * @contact: The instance.
- *
- * Gets the avatar for @contact if one is set.
- *
- * Returns: (transfer none): The avatar if set, otherwise %NULL.
- *
- * Since: 3.0.0
- */
-GdkPixbuf *purple_contact_get_avatar(PurpleContact *contact);
-
-/**
- * purple_contact_set_avatar:
- * @contact: The instance.
- * @avatar: (nullable): The new avatar to set.
- *
- * Sets the avatar for @contact to @avatar. If @avatar is %NULL an existing
- * avatar will be removed.
- *
- * Typically this should only called by the protocol plugin.
- *
- * Since: 3.0.0
- */
-void purple_contact_set_avatar(PurpleContact *contact, GdkPixbuf *avatar);
-
-/**
- * purple_contact_get_presence:
- * @contact: The instance.
- *
- * Gets the [class@Purple.Presence] for @contact.
- *
- * Returns: (transfer none) (nullable): The presence for @contact if one is
- *          set, otherwise %NULL.
- *
- * Since: 3.0.0
- */
-PurplePresence *purple_contact_get_presence(PurpleContact *contact);
-
-/**
- * purple_contact_get_tags:
- * @contact: The instance.
- *
- * Gets the [class@Purple.Tags] instance for @contact.
- *
- * Returns: (transfer none): The tags for @contact.
- *
- * Since: 3.0.0
- */
-PurpleTags *purple_contact_get_tags(PurpleContact *contact);
-
-/**
- * purple_contact_set_person:
- * @contact: The instance.
- * @person: (nullable): The new [class@Purple.Person] or %NULL.
- *
- * Sets the person that @contact belongs to to @person.
- *
- * Since: 3.0.0
- */
-void purple_contact_set_person(PurpleContact *contact, PurplePerson *person);
-
-/**
- * purple_contact_get_person:
- * @contact: The instance.
- *
- * Gets the [class@Purple.Person] that @contact belongs to.
- *
- * Returns: (transfer none) (nullable): The [class@Purple.Person] that @contact
- *          belongs to, or %NULL.
- *
- * Since: 3.0.0
- */
-PurplePerson *purple_contact_get_person(PurpleContact *contact);
-
-/**
- * purple_contact_get_permission:
- * @contact: The instance.
- *
- * Gets the [enum@Purple.ContactPermission] for @contact.
- *
- * Returns: The permission for @contact.
- *
- * Since: 3.0.0
- */
-PurpleContactPermission purple_contact_get_permission(PurpleContact *contact);
-
-/**
- * purple_contact_set_permission:
- * @contact: The instance.
- * @permission: The new permission of the contact.
- *
- * Sets the permission of @contact to @permission.
- *
- * Since: 3.0.0
- */
-void purple_contact_set_permission(PurpleContact *contact, PurpleContactPermission permission);
-
-/**
- * purple_contact_get_name_for_display:
- * @contact: The instance.
- *
- * Gets the name that should be displayed for @contact.
- *
- * If @contact is associated with a [class@Purple.Person], the value of
- * [property@Purple.Person:alias] will be returned if it is set.
- *
- * Otherwise, this will return the first set property from the following list:
- *
- *  * [property@Purple.Contact:alias]
- *  * [property@Purple.Contact:display-name]
- *  * [property@Purple.Contact:username]
- *  * [property@Purple.Contact:id]
- *
- * Returns: (transfer none): The name to display for @contact.
- *
- * Since: 3.0.0
- */
-const char *purple_contact_get_name_for_display(PurpleContact *contact);
-
-/**
- * purple_contact_compare:
- * @a: The first instance.
- * @b: The second instance.
- *
- * Compares contacts @a and @b
- *
- * Returns: less than 0 if @a should be sorted before @b, 0 if they sorted
- *          equally, and greater than 0 if @a should be sorted after @b.
- *
- * Since: 3.0.0
- */
-int purple_contact_compare(PurpleContact *a, PurpleContact *b);
-
 G_END_DECLS
 
 #endif /* PURPLE_CONTACT_H */
diff --git a/libpurple/purplecontact.h b/libpurple/purplecontactinfo.h
copy from libpurple/purplecontact.h
copy to libpurple/purplecontactinfo.h
--- a/libpurple/purplecontact.h
+++ b/libpurple/purplecontactinfo.h
@@ -20,8 +20,8 @@
 # error "only <pidgin.h> may be included directly"
 #endif
 
-#ifndef PURPLE_CONTACT_H
-#define PURPLE_CONTACT_H
+#ifndef PURPLE_CONTACT_INFO_H
+#define PURPLE_CONTACT_INFO_H
 
 #include <glib.h>
 #include <glib-object.h>
@@ -33,16 +33,16 @@
 
 G_BEGIN_DECLS
 
-#define PURPLE_TYPE_CONTACT (purple_contact_get_type())
-G_DECLARE_DERIVABLE_TYPE(PurpleContact, purple_contact, PURPLE, CONTACT,
-                         GObject)
+#define PURPLE_TYPE_CONTACT_INFO (purple_contact_info_get_type())
+G_DECLARE_DERIVABLE_TYPE(PurpleContactInfo, purple_contact_info, PURPLE,
+                         CONTACT_INFO, GObject)
 
 /**
- * PurpleContactPermission:
- * @PURPLE_CONTACT_PERMISSION_UNSET: The value is unset.
- * @PURPLE_CONTACT_PERMISSION_ALLOW: The contact is allowed to contact the
+ * PurpleContactInfoPermission:
+ * @PURPLE_CONTACT_INFO_PERMISSION_UNSET: The value is unset.
+ * @PURPLE_CONTACT_INFO_PERMISSION_ALLOW: The contact is allowed to contact the
  *                                   user.
- * @PURPLE_CONTACT_PERMISSION_DENY: The contact is not allowed to contact the
+ * @PURPLE_CONTACT_INFO_PERMISSION_DENY: The contact is not allowed to contact the
  *                                  user.
  *
  * A representation of whether or not a contact has permission to contact the
@@ -51,47 +51,41 @@
  * Since: 3.0.0
  */
 typedef enum {
-	PURPLE_CONTACT_PERMISSION_UNSET = 0,
-	PURPLE_CONTACT_PERMISSION_ALLOW,
-	PURPLE_CONTACT_PERMISSION_DENY,
-} PurpleContactPermission;
+	PURPLE_CONTACT_INFO_PERMISSION_UNSET = 0,
+	PURPLE_CONTACT_INFO_PERMISSION_ALLOW,
+	PURPLE_CONTACT_INFO_PERMISSION_DENY,
+} PurpleContactInfoPermission;
 
-#include <libpurple/account.h>
 #include <libpurple/purpleperson.h>
 
 /**
- * PurpleContactClass:
- * @get_account: A virtual method whose sole purpose is to allow
- *               [class@Purple.Account] to subclass [class@Purple.Contact].
+ * PurpleContactInfoClass:
  *
- * The class struct for [class@Purple.Contact].
+ * The class struct for [class@Purple.ContactInfo].
  *
  * Since: 3.0.0
  */
-struct _PurpleContactClass {
+struct _PurpleContactInfoClass {
 	/*< private >*/
 	GObjectClass parent;
 
-	/*< public >*/
-	PurpleAccount *(*get_account)(PurpleContact *contact);
-
 	/*< private >*/
 	gpointer reserved[4];
 };
 
 /**
- * PurpleContact:
+ * PurpleContactInfo:
  *
- * A representation of a user. Contacts are used everywhere you need to refer to
- * a user. Be it a chat, an direct message, a file transfer, etc.
+ * The information about a contact. This information is used everywhere you
+ * need to refer to a user. Be it a chat, an direct message, a file transfer,
+ * etc.
  */
 
 /**
- * purple_contact_new:
- * @account: The [class@Purple.Account] this contact is from.
+ * purple_contact_info_new:
  * @id: (nullable): The id of the contact.
  *
- * Creates a new [class@Purple.Contact].
+ * Creates a new [class@Purple.ContactInfo].
  *
  * If @id is %NULL, an ID will be randomly generated.
  *
@@ -99,26 +93,13 @@
  *
  * Since: 3.0.0
  */
-PurpleContact *purple_contact_new(PurpleAccount *account, const gchar *id);
+PurpleContactInfo *purple_contact_info_new(const gchar *id);
 
 /**
- * purple_contact_get_account:
- * @contact: The instance.
- *
- * Gets the [class@Purple.Account] that @contact belongs to.
- *
- * Returns: (transfer none): The [class@Purple.Account] that @contact belongs
- *          to.
+ * purple_contact_info_get_id:
+ * @info: The instance.
  *
- * Since: 3.0.0
- */
-PurpleAccount *purple_contact_get_account(PurpleContact *contact);
-
-/**
- * purple_contact_get_id:
- * @contact: The instance.
- *
- * Gets the id of @contact.
+ * Gets the id of @info.
  *
  * If a protocol would like to set this, it should call
  * [ctor@GObject.Object.new] and pass in the id attribute manually.
@@ -127,223 +108,223 @@
  *
  * Since: 3.0.0
  */
-const gchar *purple_contact_get_id(PurpleContact *contact);
+const gchar *purple_contact_info_get_id(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_id:
- * @contact: The instance.
+ * purple_contact_info_set_id:
+ * @info: The instance.
  * @id: The new identifier.
  *
- * Sets the identifier of @contact to @id. Note, this should be used rarely if
+ * Sets the identifier of @info to @id. Note, this should be used rarely if
  * at all. The main intent of this, is for protocols to update the id of
  * [property@Purple.Account:contact] when an account is connected if it is
  * missing.
  *
  * Since: 3.0.0
  */
-void purple_contact_set_id(PurpleContact *contact, const char *id);
+void purple_contact_info_set_id(PurpleContactInfo *info, const char *id);
 
 /**
- * purple_contact_get_username:
- * @contact: The instance.
+ * purple_contact_info_get_username:
+ * @info: The instance.
  *
- * Gets the username of @contact.
+ * Gets the username of @info.
  *
- * Returns: The username of @contact.
+ * Returns: The username of @info.
  *
  * Since: 3.0.0
  */
-const gchar *purple_contact_get_username(PurpleContact *contact);
+const gchar *purple_contact_info_get_username(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_username:
- * @contact: The instance.
+ * purple_contact_info_set_username:
+ * @info: The instance.
  * @username: The new username.
  *
- * Sets the username of @contact to @username.
+ * Sets the username of @info to @username.
  *
  * This is primarily used by protocol plugins like IRC when a user changes
  * their "nick" which is their username.
  *
  * Since: 3.0.0
  */
-void purple_contact_set_username(PurpleContact *contact, const gchar *username);
+void purple_contact_info_set_username(PurpleContactInfo *info, const gchar *username);
 
 /**
- * purple_contact_get_display_name:
- * @contact: The instance.
+ * purple_contact_info_get_display_name:
+ * @info: The instance.
  *
- * Gets the display name for @contact. The display name is typically set by the
+ * Gets the display name for @info. The display name is typically set by the
  * contact and is handled by the protocol plugin.
  *
- * Returns: (nullable): The display name of @contact if one is set, otherwise
+ * Returns: (nullable): The display name of @info if one is set, otherwise
  *          %NULL will be returned.
  *
  * Since: 3.0.0
  */
-const gchar *purple_contact_get_display_name(PurpleContact *contact);
+const gchar *purple_contact_info_get_display_name(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_display_name:
- * @contact: The instance.
+ * purple_contact_info_set_display_name:
+ * @info: The instance.
  * @display_name: (nullable): The new displayname.
  *
- * Sets the display name of @contact to @display_name.
+ * Sets the display name of @info to @display_name.
  *
  * This should primarily only be used by protocol plugins and everyone else
- * should be using [method@Purple.Contact.set_alias].
+ * should be using [method@Purple.ContactInfo.set_alias].
  *
  * Since: 3.0.0
  */
-void purple_contact_set_display_name(PurpleContact *contact, const gchar *display_name);
+void purple_contact_info_set_display_name(PurpleContactInfo *info, const gchar *display_name);
 
 /**
- * purple_contact_get_alias:
- * @contact: The instance.
+ * purple_contact_info_get_alias:
+ * @info: The instance.
  *
- * Gets the alias for @contact.
+ * Gets the alias for @info.
  *
- * Returns: (nullable): The alias of @contact if one is set, otherwise %NULL.
+ * Returns: (nullable): The alias of @info if one is set, otherwise %NULL.
  *
  * Since: 3.0.0
  */
-const gchar *purple_contact_get_alias(PurpleContact *contact);
+const gchar *purple_contact_info_get_alias(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_alias:
- * @contact: The instance.
+ * purple_contact_info_set_alias:
+ * @info: The instance.
  * @alias: (nullable): The new alias.
  *
- * Sets the alias of @contact to @alias.
+ * Sets the alias of @info to @alias.
  *
  * Protocol plugins may use this value to synchronize across instances.
  *
  * Since: 3.0.0
  */
-void purple_contact_set_alias(PurpleContact *contact, const gchar *alias);
+void purple_contact_info_set_alias(PurpleContactInfo *info, const gchar *alias);
 
 /**
- * purple_contact_get_avatar:
- * @contact: The instance.
+ * purple_contact_info_get_avatar:
+ * @info: The instance.
  *
- * Gets the avatar for @contact if one is set.
+ * Gets the avatar for @info if one is set.
  *
  * Returns: (transfer none): The avatar if set, otherwise %NULL.
  *
  * Since: 3.0.0
  */
-GdkPixbuf *purple_contact_get_avatar(PurpleContact *contact);
+GdkPixbuf *purple_contact_info_get_avatar(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_avatar:
- * @contact: The instance.
+ * purple_contact_info_set_avatar:
+ * @info: The instance.
  * @avatar: (nullable): The new avatar to set.
  *
- * Sets the avatar for @contact to @avatar. If @avatar is %NULL an existing
+ * Sets the avatar for @info to @avatar. If @avatar is %NULL an existing
  * avatar will be removed.
  *
  * Typically this should only called by the protocol plugin.
  *
  * Since: 3.0.0
  */
-void purple_contact_set_avatar(PurpleContact *contact, GdkPixbuf *avatar);
+void purple_contact_info_set_avatar(PurpleContactInfo *info, GdkPixbuf *avatar);
 
 /**
- * purple_contact_get_presence:
- * @contact: The instance.
+ * purple_contact_info_get_presence:
+ * @info: The instance.
  *
- * Gets the [class@Purple.Presence] for @contact.
+ * Gets the [class@Purple.Presence] for @info.
  *
- * Returns: (transfer none) (nullable): The presence for @contact if one is
+ * Returns: (transfer none) (nullable): The presence for @info if one is
  *          set, otherwise %NULL.
  *
  * Since: 3.0.0
  */
-PurplePresence *purple_contact_get_presence(PurpleContact *contact);
+PurplePresence *purple_contact_info_get_presence(PurpleContactInfo *info);
 
 /**
- * purple_contact_get_tags:
- * @contact: The instance.
+ * purple_contact_info_get_tags:
+ * @info: The instance.
  *
- * Gets the [class@Purple.Tags] instance for @contact.
+ * Gets the [class@Purple.Tags] instance for @info.
  *
- * Returns: (transfer none): The tags for @contact.
+ * Returns: (transfer none): The tags for @info.
  *
  * Since: 3.0.0
  */
-PurpleTags *purple_contact_get_tags(PurpleContact *contact);
+PurpleTags *purple_contact_info_get_tags(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_person:
- * @contact: The instance.
+ * purple_contact_info_set_person:
+ * @info: The instance.
  * @person: (nullable): The new [class@Purple.Person] or %NULL.
  *
- * Sets the person that @contact belongs to to @person.
+ * Sets the person that @info belongs to to @person.
  *
  * Since: 3.0.0
  */
-void purple_contact_set_person(PurpleContact *contact, PurplePerson *person);
+void purple_contact_info_set_person(PurpleContactInfo *info, PurplePerson *person);
 
 /**
- * purple_contact_get_person:
- * @contact: The instance.
+ * purple_contact_info_get_person:
+ * @info: The instance.
  *
- * Gets the [class@Purple.Person] that @contact belongs to.
+ * Gets the [class@Purple.Person] that @info belongs to.
  *
- * Returns: (transfer none) (nullable): The [class@Purple.Person] that @contact
+ * Returns: (transfer none) (nullable): The [class@Purple.Person] that @info
  *          belongs to, or %NULL.
  *
  * Since: 3.0.0
  */
-PurplePerson *purple_contact_get_person(PurpleContact *contact);
+PurplePerson *purple_contact_info_get_person(PurpleContactInfo *info);
 
 /**
- * purple_contact_get_permission:
- * @contact: The instance.
+ * purple_contact_info_get_permission:
+ * @info: The instance.
  *
- * Gets the [enum@Purple.ContactPermission] for @contact.
+ * Gets the [enum@Purple.ContactInfoPermission] for @info.
  *
- * Returns: The permission for @contact.
+ * Returns: The permission for @info.
  *
  * Since: 3.0.0
  */
-PurpleContactPermission purple_contact_get_permission(PurpleContact *contact);
+PurpleContactInfoPermission purple_contact_info_get_permission(PurpleContactInfo *info);
 
 /**
- * purple_contact_set_permission:
- * @contact: The instance.
+ * purple_contact_info_set_permission:
+ * @info: The instance.
  * @permission: The new permission of the contact.
  *
- * Sets the permission of @contact to @permission.
+ * Sets the permission of @info to @permission.
  *
  * Since: 3.0.0
  */
-void purple_contact_set_permission(PurpleContact *contact, PurpleContactPermission permission);
+void purple_contact_info_set_permission(PurpleContactInfo *info, PurpleContactInfoPermission permission);
 
 /**
- * purple_contact_get_name_for_display:
- * @contact: The instance.
+ * purple_contact_info_get_name_for_display:
+ * @info: The instance.
  *
- * Gets the name that should be displayed for @contact.
+ * Gets the name that should be displayed for @info.
  *
- * If @contact is associated with a [class@Purple.Person], the value of
+ * If @info is associated with a [class@Purple.Person], the value of
  * [property@Purple.Person:alias] will be returned if it is set.
  *
  * Otherwise, this will return the first set property from the following list:
  *
- *  * [property@Purple.Contact:alias]
- *  * [property@Purple.Contact:display-name]
- *  * [property@Purple.Contact:username]
- *  * [property@Purple.Contact:id]
+ *  * [property@Purple.ContactInfo:alias]
+ *  * [property@Purple.ContactInfo:display-name]
+ *  * [property@Purple.ContactInfo:username]
+ *  * [property@Purple.ContactInfo:id]
  *
- * Returns: (transfer none): The name to display for @contact.
+ * Returns: (transfer none): The name to display for @info.
  *
  * Since: 3.0.0
  */
-const char *purple_contact_get_name_for_display(PurpleContact *contact);
+const char *purple_contact_info_get_name_for_display(PurpleContactInfo *info);
 
 /**
- * purple_contact_compare:
+ * purple_contact_info_compare:
  * @a: The first instance.
  * @b: The second instance.
  *
@@ -354,8 +335,8 @@
  *
  * Since: 3.0.0
  */
-int purple_contact_compare(PurpleContact *a, PurpleContact *b);
+int purple_contact_info_compare(PurpleContactInfo *a, PurpleContactInfo *b);
 
 G_END_DECLS
 
-#endif /* PURPLE_CONTACT_H */
+#endif /* PURPLE_CONTACT_INFO_H */
